UniqueMUCRoom Class Reference

`#include <uniquemucroom.h>`

Inheritance diagram for UniqueMUCRoom:
[legend]

## Public Member Functions

| UniqueMUCRoom (ClientBase *parent, const JID &nick, MUCRoomHandler *mrh)
virtual | ~UniqueMUCRoom ()
Public Member Functions inherited from InstantMUCRoom
| InstantMUCRoom (ClientBase *parent, const JID &nick, MUCRoomHandler *mrh)
virtual | ~InstantMUCRoom ()
Public Member Functions inherited from MUCRoom
| MUCRoom (ClientBase *parent, const JID &nick, MUCRoomHandler *mrh, MUCRoomConfigHandler *mrch=0)
virtual | ~MUCRoom ()
void | setPassword (const std::string &password)
const std::string | name () const
const std::string | service () const
const std::string | nick () const
virtual void | join (Presence::PresenceType type=Presence::Available, const std::string &status=EmptyString, int priority=0)
void | leave (const std::string &msg=EmptyString)
void | send (const std::string &message)
void | send (const std::string &message, const std::string &subject, const StanzaExtensionList &sel=StanzaExtensionList())
void | setSubject (const std::string &subject)
MUCRoomAffiliation | affiliation () const
MUCRoomRole | role () const
void | setNick (const std::string &nick)
void | setPresence (Presence::PresenceType presence, const std::string &msg=EmptyString)
void | invite (const JID &invitee, const std::string &reason, const std::string &thread=EmptyString)
void | getRoomInfo ()
void | getRoomItems ()
void | setPublish (bool publish, bool publishNick)
void | registerMUCRoomHandler (MUCRoomHandler *mrl)
void | removeMUCRoomHandler ()
void | registerMUCRoomConfigHandler (MUCRoomConfigHandler *mrch)
void | removeMUCRoomConfigHandler ()
void | addHistory (const std::string &message, const JID &from, const std::string &stamp)
void | setRequestHistory (int value, HistoryRequestType type)
void | setRequestHistory (const std::string &since)
void | requestVoice ()
void | kick (const std::string &nick, const std::string &reason=EmptyString)
void | ban (const std::string &nick, const std::string &reason)
void | grantVoice (const std::string &nick, const std::string &reason)
void | revokeVoice (const std::string &nick, const std::string &reason)
void | setRole (const std::string &nick, MUCRoomRole role, const std::string &reason=EmptyString)
void | setAffiliation (const std::string &nick, MUCRoomAffiliation affiliation, const std::string &reason)
void | requestRoomConfig ()
void | setRoomConfig (DataForm *form)
void | acknowledgeInstantRoom ()
void | cancelRoomCreation ()
void | destroy (const std::string &reason=EmptyString, const JID &alternate=JID(), const std::string &password=EmptyString)
void | requestList (MUCOperation operation)
void | storeList (const MUCListItemList items, MUCOperation operation)
int | flags () const
virtual void | handleDiscoInfo (const JID &from, const Disco::Info &info, int context)
virtual void | handleDiscoItems (const JID &from, const Disco::Items &items, int context)
virtual void | handleDiscoError (const JID &from, const Error *error, int context)
virtual void | handlePresence (const Presence &presence)
virtual void | handleMessage (const Message &msg, MessageSession *session=0)
virtual bool | handleIq (const IQ &iq)
virtual StringList | handleDiscoNodeFeatures (const JID &from, const std::string &node)
virtual Disco::IdentityList | handleDiscoNodeIdentities (const JID &from, const std::string &node)
virtual Disco::ItemList | handleDiscoNodeItems (const JID &from, const JID &to, const std::string &node=EmptyString)
Public Member Functions inherited from IqHandler
virtual | ~IqHandler ()

## Additional Inherited Members

Public Types inherited from MUCRoom
enum | HistoryRequestType { HistoryMaxChars , HistoryMaxStanzas , HistorySeconds , HistorySince , HistoryUnknown }
enum | MUCUserOperation { OpNone , OpInviteTo , OpInviteFrom , OpDeclineTo , OpDeclineFrom }
Static Public Member Functions inherited from MUCRoom
static Message * | declineInvitation (const JID &room, const JID &invitor, const std::string &reason=EmptyString)
static Message * | createDataForm (const JID &room, const DataForm *df)
Protected Member Functions inherited from InstantMUCRoom
virtual bool | instantRoomHook () const
Protected Member Functions inherited from MUCRoom
void | setName (const std::string &name)

## Detailed Description

This class implements a unique MUC room.

A unique MUC room is a room with a non-human-readable name. It is primarily intended to be used when converting one-to-one chats to multi-user chats.

XEP version: 1.21

Author
  Jakob Schröter js@ca.nosp@m.maya.nosp@m..net

Since
  0.9

Definition at line 34 of file uniquemucroom.h.

## Constructor & Destructor Documentation

## UniqueMUCRoom()

UniqueMUCRoom | ( | ClientBase * | parent,
|  | const JID & | nick,
|  | MUCRoomHandler * | mrh )

Creates a new abstraction of a unique Multi-User Chat room. The room is not joined automatically. Use join() to join the room, use leave() to leave it. See MUCRoom for detailed info.

Parameters

  parent | The ClientBase object to use for the communication.
  nick | The service to create the room on plus the desired nickname in the form service/nick.
  mrh | The MUCRoomHandler that will listen to room events. May be 0 and may be specified later using registerMUCRoomHandler(). However, without one, MUC is no joy.

Note
  To subsequently configure the room, use MUCRoom::registerMUCRoomConfigHandler().

Definition at line 50 of file uniquemucroom.cpp.

## ~UniqueMUCRoom()

~UniqueMUCRoom | ( |  | ) |

virtual

Virtual Destructor.

Definition at line 59 of file uniquemucroom.cpp.

The documentation for this class was generated from the following files:

- uniquemucroom.h
- uniquemucroom.cpp